unit Unit1;

interface

uses unit2, unit3,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ExtCtrls;

const dx=400 ;dy =400;
      pop_size=100;
      b_rand = 0;
      b_crosfade = 1;
      b_mutate1 = 2;
      b_mutate2 = 4;      
      b_cros = 3;
type

  one = record
    way : array of word;
    price:real;
    birth:byte;//  
  end;

  Pone = ^one;

  TForm1 = class(TForm)
    Panel1: TPanel;
    SpeedButton2: TSpeedButton;
    Edit2: TEdit;
    Label2: TLabel;
    SpeedButton1: TSpeedButton;
    Panel2: TPanel;
    CheckBox1: TCheckBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label1: TLabel;
    Edit1: TEdit;
    Timer1: TTimer;
    Panel3: TPanel;
    Label3: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    SpeedButton3: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SBRgene(Sender: TObject);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure Sh;
    { Public declarations }
  end;

  vectorway = class
    pts : array of tpoint;
    way : array of word;
    price,maxprice:real;
    stat:array[0..4] of integer;
    wayfound : boolean;
    procedure randomsites(n:integer);//  n 
    constructor create;
    destructor destroy;
    procedure reset;
    function integrity(r:pointer):boolean;
    procedure Zerrulation;
    function Compare(r,r1:pointer):boolean;
    function CalcWay(r:pointer):real;
    procedure randomway(var t:one);
    procedure MutateType2(zz:pointer;ind1,ind2:integer);//ind1-, ind2-
    procedure LocalMin(zz:pointer;ind1,ind2,len:integer);//ind1 -   r ind2-     pts, len-  
    function CrossFade(t:pone):integer;
    function Crossed(a,a1,b,b1:integer):boolean;
  end;

  sr = class(Tthread)
    suspendrequest:boolean;
    exitrequest:boolean;
    constructor Create(Suspended:boolean);
    procedure Execute; override;
  end;

var
  Form1: TForm1;
  a: vectorway;
  t: tpicture;
  popul : array[1..pop_size] of one;
  z:sr;

implementation

function min(a,b:word):word;
begin
  if a>b then result:=b else result:=a;
end;

function max(a,b:word):word;
begin
  if a<b then result:=b else result:=a;
end;

procedure vectorway.reset;
var k:integer;
begin
  wayfound:=false;
  for k:=0 to 4 do stat[k]:=0;
end;

procedure vectorway.MutateType2(zz:pointer;ind1,ind2:integer);//ind1-, ind2-;
var p:array of word;
  r:word;
  k:integer;
begin
  if ind1=ind2 then exit;
  p:=zz;
  if ind1>ind2 then k:=-1 else k:=1;
  r:=p[ind1];
  while ind1<>ind2 do
  begin
    p[ind1]:=p[ind1+k];
    ind1:=ind1+k;
  end;
  p[ind2]:=r;
end;

function vectorway.Crossed(a,a1,b,b1:integer):boolean;//   
var c,c1,d,d1,x:real;
  function inside(a:real;b,c:integer):boolean;
  begin
    if (a>min(b,c)) and (a<max(b,c)) then result:=true else result:=false;
  end;
begin
  c:=(pts[a1].Y-pts[a].Y)/(pts[a1].x-pts[a].x+0.0000000001);//  ,    
  d:=pts[a1].Y-c*pts[a1].X;
  c1:=(pts[b1].Y-pts[b].Y)/(pts[b1].x-pts[b].x+0.0000000001);
  d1:=pts[b1].Y-c1*pts[b1].X;
  result:=false;
  if c<>c1 then
  begin
    x:=(d1-d)/(c-c1);//  x  
    if inside(x,pts[a1].x,pts[a].x) and inside(x,pts[b1].x,pts[b].x) then result:=true;
  end;
end;

function vectorway.CrossFade(t:pone):integer;
var k,j,mxp,ex:integer;
    r:real;
  procedure excahnge(m,n:integer);
  begin
    while m<n do
    begin
      ex:=t.way[m];
      t.way[m]:=t.way[n];
      t.way[n]:=ex;
      inc(m);
      dec(n);
    end;
  end;
begin
  result:=10;
  mxp:=length(t.way);
  for k:=0 to mxp-3 do  //     - -      
    for j:=k+2 to mxp-1 do // 1-      -      / 
      if a.Crossed(t.way[k],t.way[k+1],t.way[j],t.way[(j+1) mod (mxp-1)]) then
      begin
        result:=0;
        excahnge(k+1,j);
        r:=a.CalcWay(t.way);
        if r>t.price then
          excahnge(k+1,j)//    ,    
        else
        begin
          t.price:=r;
          t.birth:=b_crosfade;
        end;
      end;
end;

constructor sr.Create(Suspended:boolean);
begin
  inherited create(suspended);
  suspendrequest:=false;
  exitrequest:=false;
  priority:=tpIdle;
end;

function vectorway.Compare(r,r1:pointer):boolean;
var k:integer;
    p,p1:array of word;
begin
  p:=r;
  p1:=r1;
  result:=true;
  k:=min(length(p),length(p1));
  while k>0 do
  begin
    dec(k);
    if p[k]<>p1[k] then
    begin
      result:=false;
      exit;
    end;
  end;
end;

function vectorway.integrity(r:pointer):boolean;
var f:array of word;
    k,k0,mxp:integer;
label okk;
begin
  result:=false;
  f:=r;
  mxp:=length(pts)-1;
  k:=mxp;
  while k>=0 do
  begin
    k0:=mxp;
    while k0>=0 do
    begin
      if f[k0]=k then goto okk;
      dec(k0);
    end;
    exit;//   -  
okk:
    dec(k);
  end;
  result:=true;
end;

procedure vectorway.LocalMin(zz:pointer;ind1,ind2,len:integer);//ind1 -   r ind2-     pts, len-  
var p:array of word;
    mxp,k,j,j1:integer;
    flag:array of boolean;// i-  = true     
    pos:array of word;//i-    i- 
    r1,r:integer;
begin
  p:=zz;
  mxp:=length(pts);
//  setlength(flag,0);// - 
  setlength(flag,mxp);
  setlength(pos,mxp);
  for k:=0 to mxp-1 do pos[p[k]]:=k;//    -     
  flag[ind1]:=true;//   
//  flag[0]:=true;
  k:=pos[ind2];// ind2   p
  j1:=p[ind1];   //  
  p[ind1]:=ind2;
  p[k]:=j1;
  pos[ind2]:=ind1;
  pos[j1]:=k;
  while len>0 do //  for k0:=ind1 to ind1+len-2 do//  
  begin
    r1:=2000000;// 
    j:=0;//
    k:=mxp-1;// 
    while k>=0 do
    begin
      if not flag[k] then//      
      begin
        j1:=p[ind1];//  
        r:=sqr(a.pts[j1].X-a.pts[k].X)+sqr(a.pts[j1].y-a.pts[k].y);// 
        if r<r1 then
        begin
          r1:=r;    // 
          j:=k;
        end;
      end;
      dec(k);
    end;
    if r1=2000000 then exit;//   
// j - number of pretendent for change - closest city to city ind
    ind2:=ind1+1;
    if ind2=mxp then ind2:=1;
    k:=pos[j];//   j   p
    j1:=p[ind2];// p[k]  p[k0+1]
    p[ind2]:=j;
    p[k]:=j1;
    pos[j]:=ind2;// 
    pos[j1]:=k;
    flag[j]:=true;// j- 
    inc(ind1);
    if ind1>=mxp then ind1:=0;// ind1=mpx+1   -   
    dec(len);
  end;
end;

procedure vectorway.randomway(var t:one);
var k,j,j1:integer;
    a:word;
begin
  k:=length(pts)-1;
  setlength(t.way,k+1);
  t.birth:=b_rand;
  for j:=0 to k do t.way[j]:=j;//  
  for j:=0 to k do
  begin
    j1:=random(k);
    if j1<>j then//     
    begin
      a:=t.way[j];
      t.way[j]:=t.way[j1];
      t.way[j1]:=a;
    end;
  end;
end;

function vectorway.calcway(r:pointer):real;
var d:array of word;
    k,j1,j2:integer;
begin
  d:=r;
  result:=0;
  for k:=0 to length(d)-2 do
  begin
    j1:=d[k];
    j2:=d[k+1];
    result:=result+sqrt(sqr(pts[j1].X-pts[j2].X)+sqr(pts[j1].Y-pts[j2].Y));
  end;
  j1:=d[0];//    
  result:=result+sqrt(sqr(pts[j1].X-pts[j2].X)+sqr(pts[j1].Y-pts[j2].Y));
end;

constructor vectorway.create;
begin
  inherited create;
  Zerrulation;
end;

destructor vectorway.destroy;
begin
  Zerrulation;
  inherited destroy;
end;

procedure vectorway.Zerrulation;
begin
  setlength(pts,0);
  setlength(way,0);
  reset;
end;

procedure vectorway.randomsites(n:integer);//  n 
var k,j:integer;
label sgs;
begin
  setlength(pts,n);
  setlength(way,n);
  reset;
  for k:=0 to n-1 do
  begin
sgs:
    pts[k].X:=random(dx);
    pts[k].Y:=random(dy);
    if k>0 then
      for j:=0 to k-1 do
        if sqr(pts[j].X-pts[k].X)+sqr(pts[j].Y-pts[k].Y)<36 then goto sgs;
  end;
end;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  randomize;
  a:=vectorway.create;
  t:=tpicture.Create;
  t.Bitmap.Width:=dx;
  t.Bitmap.Height:=dy;
  z:=sr.Create(true);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  z.exitrequest:=true;
  z.Resume;
  while z.exitrequest do sleep(100); // 
  z.Destroy;
  a.destroy;
  t.Destroy;
end;

procedure Tform1.Sh;
  procedure showcitys;
  var k:integer;
      zz:Tcanvas;
  begin
    zz:=t.bitmap.canvas;
    zz.Brush.Color:=color;
    zz.Rectangle(0,0,dx,dy);
    for k:=0 to length(a.pts)-1 do
    begin
      if k=0 then zz.Brush.Color:=clblack else zz.Brush.Color:=color;
      zz.Ellipse(a.pts[k].X-2,a.pts[k].y-2,a.pts[k].X+2,a.pts[k].y+2);
    end;
    zz.Brush.Color:=color;
    if a.wayfound then
    begin
      zz.MoveTo(a.pts[a.way[0]].x,a.pts[a.way[0]].y);
      for k:=1 to length(a.way)-1 do
        zz.LineTo(a.pts[a.way[k]].X,a.pts[a.way[k]].y);
      zz.LineTo(a.pts[a.way[0]].X,a.pts[a.way[0]].y);//  
    end;
  end;
  var aaa:real;
begin
  showcitys;
  canvas.CopyRect(rect(1,1,dx+1,dy+1),t.Bitmap.Canvas,rect(0,0,dx,dy));
  if a.wayfound then
  begin
    aaa:=a.calcway(a.way);
    label12.caption:=floattostr(aaa);
    label13.caption:=format('%f %%',[100*aaa/a.maxprice]);
    label5.Caption:=inttostr(a.stat[2]);
    label7.Caption:=inttostr(a.stat[1]);
    label9.Caption:=inttostr(a.stat[3]);
    label11.Caption:=inttostr(a.stat[4]);
  end;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  Sh;
end;

procedure TForm1.SBRgene(Sender: TObject);
var n:integer;
begin
  try
    n:=strtoint(edit1.text);
  except
    on Econverterror do n:=0;
  end;
  if n>2000 then n:=2000;
  if n<3 then n:=3;
  edit1.Text:=inttostr(n);
  a.randomsites(n);
  sh;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  if length(a.pts)<=2 then exit;
  z.Resume;
  timer1.Interval:=length(a.pts);
  if timer1.Interval<300 then timer1.Interval:=300;
  if timer1.Interval>2000 then timer1.Interval:=2000;
  timer1.Enabled:=true;
  form2.showmodal;//-
  z.suspendrequest:=true;
  while not z.suspendrequest do sleep(100);
  sh;
  timer1.Enabled:=false;
end;

procedure sr.Execute;
const Co=2;
var ng,k0,k,j,j1,mxp:integer;
    minval,maxval:integer;//   
    best:word;//   - 
    fc:array[1..pop_size] of one;
    M,mst:integer;//    
    r:real;
    bra:word;
    cros_count,locmin_len:integer;
//    virra: array of word;//  
label nxt_gen,aga,elite,nxt_genseries,fina,start;
  function getgennum:integer;
  begin
    try //  
      result:=strtoint(form1.edit2.Text);
    except
      on Econverterror do result:=0;
    end;
    if Result<10 then result:=10;   //  
  end;
begin
start:
  mxp:=length(a.pts);// 
  if mxp<2 then goto fina;
  mst:=1;//  round(ln(mxp)); //    
//    k 
  setlength(a.way,mxp);//     -    
  for k:=1 to pop_size do
  begin
    a.randomway(popul[k]);//  
    setlength(fc[k].way,mxp);//    
  end;
  cros_count:=0;//       
  locmin_len:=trunc(sqrt(mxp)); //    
// 
  best:=1;//  -    
  if a.wayfound then//   - ,     
    copymemory(popul[best].way,a.way,mxp*sizeof(word))
  else //    
  begin
    a.price:=1e22;
    a.LocalMin(popul[best].way,0,0,mxp);
    popul[best].birth:=b_cros;
  end;
nxt_genseries:
  ng:=GetGenNum;//   
  m:=1+random(mst);//      
nxt_gen:
  minval:=2000000; maxval:=0;//  
  dec(cros_count);
  if cros_count<=0 then cros_count:=a.CrossFade(@popul[best]);//     
  for k0:=1 to pop_size do    //  
  begin
    if k0=best then goto elite;//       . 
// -  
    r:=random;
    if r<0.34 then
    begin
      for j1:=1 to m do//
      begin
        k:=random(mxp);
//        j:=min(2+random(mxp div 3),10);
        j:=2+random(locmin_len);
        a.LocalMin(popul[k0].way,k,popul[k0].way[k],j);
      end;
      popul[k0].birth:=b_cros;
    end else
      if r<0.67 then// 1 -    
      begin
        for k:=1 to m do
        begin
          j:=random(mxp);
          j1:=random(mxp);
          if j<>j1 then
          begin
            bra:=popul[k0].way[j];
            popul[k0].way[j]:=popul[k0].way[j1];
            popul[k0].way[j1]:=bra;
          end;
        end;
        popul[k0].birth:=b_mutate1;
      end else // 2 -    
      begin
//        for k:=1 to m do
        a.MutateType2(popul[k0].way,random(mxp),random(mxp));
        popul[k0].birth:=b_mutate2;
      end;
// 
elite:
    r:=a.CalcWay(popul[k0].way);
    if r<minval then minval:=round(r);
    if r>maxval then maxval:=round(r);
    popul[k0].price:=r;
  end;
  maxval:=minval+((maxval-minval)*1) shr 4 ;// 
  minval:=0;
//  maxval:=(maxval+minval) shr 1;// 
  for k:=1 to pop_size do
    if popul[k].price<=maxval then //     
    begin           //     - 
      inc(minval);
      fc[minval].price:=popul[k].price;
      fc[Minval].birth:=popul[k].birth;
      copymemory(fc[minval].way,popul[k].way,mxp*sizeof(word));
    end;
  maxval:=minval;
  while maxval<pop_size do//  
  begin
    k:=1+random(minval); // -  
    inc(maxval);
    fc[maxval].price:=popul[k].price;
    fc[Maxval].birth:=popul[k].birth;
    copymemory(fc[maxval].way,popul[k].way,mxp*sizeof(word));
  end;
  r:=2000000;//  
  for k:=1 to pop_size do//    
  begin
    popul[k].price:=fc[k].price;
    popul[k].birth:=fc[k].birth;
    copymemory(popul[k].way,fc[k].way,mxp*sizeof(word));
    if popul[k].price<r then
    begin
      r:=popul[k].price;
      best:=k;
    end;
  end;
//  if not a.Compare(popul[best].way,a.way) then
  if popul[best].price<a.price then
  begin
  // 
    copymemory(a.way,popul[best].way,mxp*sizeof(word));
    a.price:=popul[best].price;
    if not a.wayfound then a.maxprice:=a.price;
    inc(a.stat[popul[best].birth]);
    a.wayfound:=true;
  end;
  dec(ng);// 
  if (ng>0) and (not suspendrequest) then goto nxt_gen;
//  form1.sh;//form1.Invalidate;
  if not (suspendrequest or exitrequest) then goto nxt_genseries;
fina:
  suspendrequest:=false;
  suspend;
  if exitrequest then
  begin
    exitrequest:=false;
    exit;  //        execute
  end;
  goto start;
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var k:integer;
begin
  k:=length(a.pts);
  if mbRight = button then//
  begin
    if k>0 then setlength(a.pts,k-1);
    edit1.Text:=inttostr(k-1);    
    a.Reset;
  end;
  if mbLeft = button then//  
  begin
    setlength(a.pts,k+1);
    a.reset;
    a.pts[k].X:=x-1;
    a.pts[k].y:=y-1;
    edit1.Text:=inttostr(k+1);
  end;
  Sh;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  sh;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  form3.show;
end;

end.
